\documentclass{article}
\usepackage{graphicx}
\usepackage{listings}
\usepackage{amsmath}
\usepackage{xcolor}
\usepackage{mathtools}
\usepackage[all,cmtip]{xy}
\usepackage{amsfonts}
\usepackage{amssymb}

\begin{document}

\title{Combinatorics on words assignment 1}
\author{Luke Naylor}

\maketitle

\section*{Question 1}
Given the definition of the Thue-Morse sequence, it is sufficient to show that $11$ and $00$ only appear at even positions in each of the words $\theta^n(0)$.
For $n=0$, $\theta^n(0) = 0$ does not have $00$ or $11$ as a factor. For $n\geq1$, it is sufficient to show that for any word $w$, $\theta(w)$ does not contain $11$ or $00$ as a factor at odd positions. \\
To show this, notice that the $2$ letter factor at position $2m+1$ in $\theta(w)$ is $\theta(l)$ where $l$ is the $(m+1)^{\mathrm{th}}$ letter of $w$. This is because $\theta$ sends each letter to a 2 letter word. But $\theta(l)$ is $01$ if $l=0$ and $10$ if $l=1$ so cannot be $00$ or $11$. \\
$\therefore 00$ and $11$ only appear as factors of the Thue-Morse sequence in even positions.

\section*{Question 2}
Let's draw the adjacency graph for the pattern $\alpha \beta \sigma_1 \beta \gamma \sigma_2 \gamma \gamma \alpha \sigma_3 \beta \alpha \sigma_4 \alpha \gamma$.
\[
\xymatrix{
    \alpha^L
        \ar@{-}[rd]
        \ar@{-}[rrd]
        \ar@{-}[rrrrrd]
        \ar@{-}[rrrrrrd]
    &\beta^L
        \ar@{-}[ld]
        \ar@{-}[rd]
        \ar@{-}[rrd]
    &\gamma^L
        \ar@{-}[lld]
        \ar@{-}[rrd]
    &\sigma_1^L
        \ar@{-}[lld]
    &\sigma_2^L
        \ar@{-}[lld]
    &\sigma_3^L
        \ar@{-}[lllld]
    &\sigma_4^L
        \ar@{-}[lllllld]
    \\
    \alpha^R
    &\beta^R
    &\gamma^R
    &\sigma_1^R
    &\sigma_2^R
    &\sigma_3^R
    &\sigma_4^R
}
\]
Notice that this graph is connected so there are no free sets for this pattern. Therefore the Zimin algorithm stops at the first step, and so this pattern is irreducible. By Theorem 3.1 of lecture 3, this pattern is therefore avoidable.
\section*{Question 3}
First of all, $02$ is a factor of $2020$ an $10$ is a factor of $2101$. So to avoid $\{02,10,2020,2101,2001\}$, it is sufficient to avoid $\{02,10,2001\}$, and none of these 3 words is a factor of another.
Let $b_1 = 02$, $b_2 = 10$ and $b_3 = 2001$.\\
Now let's calculate the correlation words for $b_1,b_2,b_3$:
\[
    \xymatrix{
         c_{11} = 10
        &c_{21} = 00
        &c_{31} = 0001
        \\
         c_{12} = 01
        &c_{22} = 10
        &c_{32} = 0000
        \\
         c_{13} = 00
        &c_{23} = 01
        &c_{33} = 1000
    }
\]
Now compute the determinants that appear in the Theorem 1.1 of lecture 4.
% Start of determinant in numerator of generating function
\[
    \begin{vmatrix}
         -c_{11}(x)
        &\cdots
        &-c_{1n}(x)
        \\
         \vdots
        &\ddots
        &\vdots
        \\
         -c_{n1}(x)
        &\cdots
        &-c_{nn}(x)
    \end{vmatrix}
    =
    -
    \begin{vmatrix}
         1
        &0
        &x^3
        \\
         x
        &1
        &0
        \\
         0
        &x
        &1
    \end{vmatrix}
    =
    - \left(
    \begin{vmatrix}
         1
        &0
        \\
         x
        &1
    \end{vmatrix}
    +x^3
    \begin{vmatrix}
         x
        &1
        \\
         0
        &x
    \end{vmatrix}
    \right)
    = -1-x^5
\]

% Start of determinant in denominator of generating function
\begin{align*}
    \begin{vmatrix}
         1-9x
        &1
        &\cdots
        &1
        \\
         x^{l_1}
        &-c_{11}(x)
        &\cdots
        &-c_{1n}(x)
        \\
         \vdots
        &\vdots
        &\ddots
        &\vdots
        \\
         x^{l_n}
        &-c_{n1}(x)
        &\cdots
        &-c_{nn}(x)
    \end{vmatrix}
    &=
    \begin{vmatrix}
         1-9x
        &1
        &1
        &1
        \\
         x^2
        &-1
        &-x
        &0
        \\
         x^2
        &0
        &-1
        &-x
        \\
         x^4
        &-x^3
        &0
        &-1
    \end{vmatrix}
    \\
    &=
    -x^4
    \begin{vmatrix}
         1
        &1
        &1
        \\
         -1
        &-x
        &0
        \\
         0
        &-1
        &-x
    \end{vmatrix}
    -x^3
    \begin{vmatrix}
         1-9x
        &1
        &1
        \\
         x^2
        &-x
        &0
        \\
         x^2
        &-1
        &-x
    \end{vmatrix}
    -
    \begin{vmatrix}
         1-9x
        &1
        &1
        \\
         x^2
        &-1
        &-x
        \\
         x^2
        &0
        &-1
    \end{vmatrix}
    \\
    &=
    -x^4
    \left(
         x^2+1-x
    \right)
    -x^3
    \left(
         (-x^2+x^3)-x(9x^2-x-x^2)
    \right)
    \\
    &\quad-
    \left(
        x^2(1-x)-(9x-1-x^2)
    \right)
    \\
    &=
    - x^6 - x^4 + x^5 + x^5 - x^6 + 8x^6 - x^5 - x^2 + x^3 + 9x - 1 - x^2
    \\
    &=
    x^6 + x^5 - x^4 + x^3 - 2x^2 + 9x - 1
\end{align*}

Therefore the generating function for the words with letters $\{0,1,2,3,4,5,6,7,8\}$ that avoid factors in $\{02,10,2020,2101,2001\}$ is:
\[
    S(x) =  \frac{-1-x^5}{x^6 + x^5 - x^4 + x^3 - 2x^2 + 9x - 1}
\]

\section*{Question 4}
$A=011$ and $B=001$, notice that both these words start with a $0$. So in the Penney's game, neither words may appear until the first $0$ (heads) appears.
So the probability of $B$ winning at the start of the game is the same as when the first $0$ appears.
Also consider the situation where neither $A$ nor $B$ has won yet and the current sequence ends with a single $0$ (but does not end with $00$).
Either the current sequence is just $0$ in which case this is the same scenario as before (the first $0$ has just appeared) or the sequence ends in $10$.
$10$ is not a factor of either $A$ or $B$ so both patterns can only start at the final $0$ at the earliest.
So this is essentially the same situation as when the first $0$ appears with respect to who is more likely to win.
\\
\\
This is all to say that the probabilities of $B$ winning given any of the following events, is the same:
\begin{itemize}
 \item a: the game has just started
 \item b: the first $0$ has not appeared yet
 \item c: the first $0$ has just appeared
 \item d: nobody has won yet and the current sequence ends with a single $0$ (not $00$)
\end{itemize}
Note also that if nobody has won yet and the current sequence ends with $00$, then $B$ is guaranteed to win (as soon as the next $1$ appears).
\\
\\
Consider the event tree starting from event c described above:
\[
    \xymatrix{
        %
        &\text{\textcolor{blue}{event c}}
            \ar[ld]
            \ar[rd]
        &
        &
        \\
         0 \:\text{\textcolor{blue}{ B will win}}
        &
        &1
            \ar[ld]
            \ar[rd]
        &
        \\
         %
        &0 \:\text{\textcolor{blue}{ event d}}
        &
        &1 \:\text{\textcolor{blue}{ A wins}}
    }
\]

\begin{align*}
    \mathbb{P}(\text{B wins}\:|\:\text{event c}) &= \frac12 + \frac14\mathbb{P}(\text{B wins} \:|\: \text{event d}) \\
    \frac34 \mathbb{P}(\text{B wins}) &= \frac12 \\
    \mathbb{P}(\text{B wins}) &= \frac23
\end{align*}

\section*{Question 5}
Consider:
$$(22)(23)(24)(21)(20)(18)(19)3(17)42(16)1567(11)(10)8(13)9(12)(15)(14)$$
Notice the factor 1567(11) at position 13. Both 1567 and 567(11) are ordered, so both reduce to the permutation 1234. \\
\textbf{Therefore, this is not a universal cycle for permutations of length 4.}\\
\\
It turns out that there is only one other repeated reduced permutation in this cycle: 1243. The following python program identifies this.

\definecolor{codegreen}{rgb}{0,0.6,0}
\definecolor{codegray}{rgb}{0.5,0.5,0.5}
\definecolor{codepurple}{rgb}{0.58,0,0.82}
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}

\lstdefinestyle{mystyle}{
    backgroundcolor=\color{backcolour},
    commentstyle=\color{codegreen},
    keywordstyle=\color{magenta},
    numberstyle=\tiny\color{codegray},
    stringstyle=\color{codepurple},
    basicstyle=\ttfamily\footnotesize,
    breakatwhitespace=false,
    breaklines=true,
    captionpos=b,
    keepspaces=true,
    numbers=left,
    numbersep=5pt,
    showspaces=false,
    showstringspaces=false,
    showtabs=false,
    tabsize=2
}

\lstset{style=mystyle}
\lstinputlisting[language=Python]{Exercise5.py}
The output for this program is:
\begin{verbatim}
Reduced permutation (1, 2, 3, 4) at position 14 already appeared at position 13
Reduced permutation (1, 2, 4, 3) at position 21 already appeared at position 15
Reduced permutation (1, 2, 3, 4) at position 24 already appeared at position 13
\end{verbatim}

\end{document}
